<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Listado de cursantes</div>
    <q-banner
      inline-actions
      class="text-white bg-red"
      v-if="MembresiaListadoStore.filtros.rama.includes('G')"
    >
      Por limitacion de la informacion que tiene el aplicativo, cuando se
      selecciona Rama Gestión, obtiene todas las pesonas que no tienen una rama
      definida
    </q-banner>

    <q-card class="q-mt-sm">
      <q-list bordered>
        <q-expansion-item icon="filter_alt" label="Filtros Avanzados">
          <template v-slot:header>
            <q-item-section> Filtros Avanzados </q-item-section>
            <q-item-section side v-if="MembresiaListadoStore.filtroActivado">
              <q-badge color="blue"> Existe un filtro aplicado </q-badge>
            </q-item-section>
          </template>
          <q-card>
            <q-card-section>
              <div class="q-col-gutter-md row">
                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="MembresiaListadoStore.filtros.query"
                  label="Buscar"
                  stack-label
                  dense
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="MembresiaListadoStore.filtros.afiliado"
                  :options="membresiaListadoSelect.afiliado"
                  label="Estado"
                  dense
                  multiple
                  use-chips
                  emit-value
                  stack-label
                  map-options
                />

                <selectOrganismos
                  class="col col-sm-4 col-xs-12"
                  v-model="MembresiaListadoStore.filtros.organismos"
                  :filled="false"
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="MembresiaListadoStore.filtros.im"
                  :options="membresiaListadoSelect.im"
                  label="Insignia de Madera"
                  dense
                  use-chips
                  emit-value
                  stack-label
                  map-options
                />
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <q-btn flat color="primary" @click="onFiltrar">Filtrar</q-btn>
              <q-btn flat color="red" @click="onResetFiltros">
                Borrar Filtro
              </q-btn>
            </q-card-actions>
          </q-card>
        </q-expansion-item>
      </q-list>
    </q-card>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="MembresiaListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <PersonaDetalle :persona="props.row" />
          </q-td>
        </template>

        <template v-slot:body-cell-funciones="props">
          <q-td :props="props">
            <PersonaFuncion :funciones="props.row.funciones" />
          </q-td>
        </template>
        <template v-slot:body-cell-rama="props">
          <q-td :props="props">
            <ItemRama :rama="props.row.rama_codigo" />
          </q-td>
        </template>

        <template v-slot:body-cell-info="props">
          <q-td :props="props">
            <q-item class="max-w">
              <q-item-section>
                <q-item-label caption lines="1">
                  <span>Nacimiento :</span>
                  {{ $filters.Date(props.row.nacimiento) }}
                </q-item-label>
                <q-item-label caption lines="2">
                  <span>Categoria :</span>
                  {{ props.row.categoria }}
                </q-item-label>
                <q-item-label caption lines="2" v-if="props.row.totem">
                  <span>Totem :</span>
                  {{ props.row.totem }}
                </q-item-label>
                <q-item-label caption lines="2" v-if="props.row.email">
                  <span>Email :</span>
                  {{ props.row.email }}
                </q-item-label>
                <q-item-label caption lines="2" v-if="props.row.trabajo">
                  <span>Trabajo :</span>
                  {{ props.row.trabajo }}
                </q-item-label>

                <q-item-label
                  caption
                  lines="2"
                  v-if="props.row.necesidad_especial"
                >
                  <span>Necesidad Especial :</span>
                  {{ props.row.necesidad_especial }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              square
              flat
              size="sm"
              color="primary"
              icon="person_search"
              label="Formacion"
              :to="'/formacion/cursantes/detalle/' + props.row.uuid"
            />
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import {
  useMembresiaListadoStore,
  membresiaListadoSelect,
} from 'src/stores/membresia/listado';
import Loading from 'src/components/Loading.vue';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonaFuncion from 'components/Personas/Funciones.vue';
import ItemRama from 'src/components/Util/ItemRama.vue';
import selectOrganismos from 'src/components/Form/selectOrganismos.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  {
    name: 'funciones',
    label: 'Funciones',
    field: 'Funciones',
    align: 'left',
  },
  { name: 'rama', label: 'Rama', field: 'rama', align: 'left' },
  { name: 'info', label: 'info', field: 'info', align: 'left' },

  { name: 'opciones', label: 'opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: {
    Loading,
    PersonaDetalle,
    PersonaFuncion,
    ItemRama,
    selectOrganismos,
  },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const MembresiaListadoStore = useMembresiaListadoStore();

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      MembresiaListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      MembresiaListadoStore.filtroActivado = true;
      MembresiaListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/persona/personas', {
          params: { ...MembresiaListadoStore.parametros, tipo: 'A' },
        })
        .then((response: AxiosResponse) => {
          MembresiaListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      MembresiaListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      loading,
      columnas,
      dataSet,
      MembresiaListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      membresiaListadoSelect,
    };
  },
});
</script>
